/* graph-block-row.c generated by valac 0.42.0, the Vala compiler
 * generated from graph-block-row.vala, do not modify */

/* graph-block-row.vala
 *
 * Copyright (C) 2017 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Petr Štětka <pstetka@redhat.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>


#define USAGE_TYPE_GRAPH_BLOCK_ROW (usage_graph_block_row_get_type ())
#define USAGE_GRAPH_BLOCK_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_GRAPH_BLOCK_ROW, UsageGraphBlockRow))
#define USAGE_GRAPH_BLOCK_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_GRAPH_BLOCK_ROW, UsageGraphBlockRowClass))
#define USAGE_IS_GRAPH_BLOCK_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_GRAPH_BLOCK_ROW))
#define USAGE_IS_GRAPH_BLOCK_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_GRAPH_BLOCK_ROW))
#define USAGE_GRAPH_BLOCK_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_GRAPH_BLOCK_ROW, UsageGraphBlockRowClass))

typedef struct _UsageGraphBlockRow UsageGraphBlockRow;
typedef struct _UsageGraphBlockRowClass UsageGraphBlockRowClass;
typedef struct _UsageGraphBlockRowPrivate UsageGraphBlockRowPrivate;

#define USAGE_TYPE_GRAPH_BLOCK_TYPE (usage_graph_block_type_get_type ())
enum  {
	USAGE_GRAPH_BLOCK_ROW_0_PROPERTY,
	USAGE_GRAPH_BLOCK_ROW_NUM_PROPERTIES
};
static GParamSpec* usage_graph_block_row_properties[USAGE_GRAPH_BLOCK_ROW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define USAGE_TYPE_COLOR_RECTANGLE (usage_color_rectangle_get_type ())
#define USAGE_COLOR_RECTANGLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_COLOR_RECTANGLE, UsageColorRectangle))
#define USAGE_COLOR_RECTANGLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_COLOR_RECTANGLE, UsageColorRectangleClass))
#define USAGE_IS_COLOR_RECTANGLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_COLOR_RECTANGLE))
#define USAGE_IS_COLOR_RECTANGLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_COLOR_RECTANGLE))
#define USAGE_COLOR_RECTANGLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_COLOR_RECTANGLE, UsageColorRectangleClass))

typedef struct _UsageColorRectangle UsageColorRectangle;
typedef struct _UsageColorRectangleClass UsageColorRectangleClass;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _UsageGraphBlockRow {
	GtkBox parent_instance;
	UsageGraphBlockRowPrivate * priv;
};

struct _UsageGraphBlockRowClass {
	GtkBoxClass parent_class;
};

typedef enum  {
	USAGE_GRAPH_BLOCK_TYPE_PROCESSOR,
	USAGE_GRAPH_BLOCK_TYPE_MEMORY,
	USAGE_GRAPH_BLOCK_TYPE_DISK,
	USAGE_GRAPH_BLOCK_TYPE_NETWORK
} UsageGraphBlockType;

struct _UsageGraphBlockRowPrivate {
	GtkLabel* value_label;
	UsageGraphBlockType type;
};


static gint UsageGraphBlockRow_private_offset;
static gpointer usage_graph_block_row_parent_class = NULL;

GType usage_graph_block_row_get_type (void) G_GNUC_CONST;
GType usage_graph_block_type_get_type (void) G_GNUC_CONST;
UsageGraphBlockRow* usage_graph_block_row_new (UsageGraphBlockType type,
                                               const gchar* label_text,
                                               const gchar* css_class);
UsageGraphBlockRow* usage_graph_block_row_construct (GType object_type,
                                                     UsageGraphBlockType type,
                                                     const gchar* label_text,
                                                     const gchar* css_class);
GType usage_color_rectangle_get_type (void) G_GNUC_CONST;
UsageColorRectangle* usage_color_rectangle_new_new_from_css (const gchar* css_class);
UsageColorRectangle* usage_color_rectangle_construct_new_from_css (GType object_type,
                                                                   const gchar* css_class);
void usage_graph_block_row_update (UsageGraphBlockRow* self,
                                   guint64 value);
gchar* usage_utils_format_size_values (guint64 value);
gchar* usage_utils_format_size_speed_values (guint64 value);
static void usage_graph_block_row_finalize (GObject * obj);


static inline gpointer
usage_graph_block_row_get_instance_private (UsageGraphBlockRow* self)
{
	return G_STRUCT_MEMBER_P (self, UsageGraphBlockRow_private_offset);
}


UsageGraphBlockRow*
usage_graph_block_row_construct (GType object_type,
                                 UsageGraphBlockType type,
                                 const gchar* label_text,
                                 const gchar* css_class)
{
	UsageGraphBlockRow * self = NULL;
	UsageColorRectangle* color_rectangle = NULL;
	UsageColorRectangle* _tmp0_;
	GtkLabel* label = NULL;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	g_return_val_if_fail (label_text != NULL, NULL);
	g_return_val_if_fail (css_class != NULL, NULL);
	self = (UsageGraphBlockRow*) g_object_new (object_type, "orientation", GTK_ORIENTATION_HORIZONTAL, NULL);
	_tmp0_ = usage_color_rectangle_new_new_from_css (css_class);
	g_object_ref_sink (_tmp0_);
	color_rectangle = _tmp0_;
	_tmp1_ = (GtkLabel*) gtk_label_new (label_text);
	g_object_ref_sink (_tmp1_);
	label = _tmp1_;
	g_object_set ((GtkWidget*) label, "margin", 5, NULL);
	gtk_label_set_ellipsize (label, PANGO_ELLIPSIZE_END);
	gtk_label_set_max_width_chars (label, 15);
	_tmp2_ = (GtkLabel*) gtk_label_new ("0 %");
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->value_label);
	self->priv->value_label = _tmp2_;
	_tmp3_ = self->priv->value_label;
	gtk_label_set_width_chars (_tmp3_, 5);
	_tmp4_ = self->priv->value_label;
	gtk_label_set_width_chars (_tmp4_, 5);
	_tmp5_ = self->priv->value_label;
	gtk_label_set_xalign (_tmp5_, (gfloat) 1);
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) color_rectangle, FALSE, FALSE, (guint) 0);
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) label, FALSE, TRUE, (guint) 5);
	_tmp6_ = self->priv->value_label;
	gtk_box_pack_end ((GtkBox*) self, (GtkWidget*) _tmp6_, FALSE, TRUE, (guint) 10);
	self->priv->type = type;
	_g_object_unref0 (label);
	_g_object_unref0 (color_rectangle);
	return self;
}


UsageGraphBlockRow*
usage_graph_block_row_new (UsageGraphBlockType type,
                           const gchar* label_text,
                           const gchar* css_class)
{
	return usage_graph_block_row_construct (USAGE_TYPE_GRAPH_BLOCK_ROW, type, label_text, css_class);
}


void
usage_graph_block_row_update (UsageGraphBlockRow* self,
                              guint64 value)
{
	UsageGraphBlockType _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->type;
	switch (_tmp0_) {
		case USAGE_GRAPH_BLOCK_TYPE_PROCESSOR:
		{
			GtkLabel* _tmp1_;
			gchar* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			_tmp1_ = self->priv->value_label;
			_tmp2_ = g_strdup_printf ("%" G_GUINT64_FORMAT, value);
			_tmp3_ = _tmp2_;
			_tmp4_ = g_strconcat (_tmp3_, " %", NULL);
			_tmp5_ = _tmp4_;
			gtk_label_set_text (_tmp1_, _tmp5_);
			_g_free0 (_tmp5_);
			_g_free0 (_tmp3_);
			break;
		}
		case USAGE_GRAPH_BLOCK_TYPE_MEMORY:
		{
			GtkLabel* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			_tmp6_ = self->priv->value_label;
			_tmp7_ = usage_utils_format_size_values (value);
			_tmp8_ = _tmp7_;
			gtk_label_set_text (_tmp6_, _tmp8_);
			_g_free0 (_tmp8_);
			break;
		}
		case USAGE_GRAPH_BLOCK_TYPE_NETWORK:
		{
			GtkLabel* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			_tmp9_ = self->priv->value_label;
			_tmp10_ = usage_utils_format_size_speed_values (value);
			_tmp11_ = _tmp10_;
			gtk_label_set_text (_tmp9_, _tmp11_);
			_g_free0 (_tmp11_);
			break;
		}
		default:
		break;
	}
}


static void
usage_graph_block_row_class_init (UsageGraphBlockRowClass * klass)
{
	usage_graph_block_row_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &UsageGraphBlockRow_private_offset);
	G_OBJECT_CLASS (klass)->finalize = usage_graph_block_row_finalize;
}


static void
usage_graph_block_row_instance_init (UsageGraphBlockRow * self)
{
	self->priv = usage_graph_block_row_get_instance_private (self);
}


static void
usage_graph_block_row_finalize (GObject * obj)
{
	UsageGraphBlockRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, USAGE_TYPE_GRAPH_BLOCK_ROW, UsageGraphBlockRow);
	_g_object_unref0 (self->priv->value_label);
	G_OBJECT_CLASS (usage_graph_block_row_parent_class)->finalize (obj);
}


GType
usage_graph_block_row_get_type (void)
{
	static volatile gsize usage_graph_block_row_type_id__volatile = 0;
	if (g_once_init_enter (&usage_graph_block_row_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UsageGraphBlockRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) usage_graph_block_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UsageGraphBlockRow), 0, (GInstanceInitFunc) usage_graph_block_row_instance_init, NULL };
		GType usage_graph_block_row_type_id;
		usage_graph_block_row_type_id = g_type_register_static (gtk_box_get_type (), "UsageGraphBlockRow", &g_define_type_info, 0);
		UsageGraphBlockRow_private_offset = g_type_add_instance_private (usage_graph_block_row_type_id, sizeof (UsageGraphBlockRowPrivate));
		g_once_init_leave (&usage_graph_block_row_type_id__volatile, usage_graph_block_row_type_id);
	}
	return usage_graph_block_row_type_id__volatile;
}



