/* process.c generated by valac 0.42.0, the Vala compiler
 * generated from process.vala, do not modify */

/* process.vala
 *
 * Copyright (C) 2017 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Petr Štětka <pstetka@redhat.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>


#define USAGE_TYPE_PROCESS (usage_process_get_type ())
#define USAGE_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_PROCESS, UsageProcess))
#define USAGE_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_PROCESS, UsageProcessClass))
#define USAGE_IS_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_PROCESS))
#define USAGE_IS_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_PROCESS))
#define USAGE_PROCESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_PROCESS, UsageProcessClass))

typedef struct _UsageProcess UsageProcess;
typedef struct _UsageProcessClass UsageProcessClass;
typedef struct _UsageProcessPrivate UsageProcessPrivate;

#define USAGE_TYPE_PROCESS_STATUS (usage_process_status_get_type ())
enum  {
	USAGE_PROCESS_0_PROPERTY,
	USAGE_PROCESS_PID_PROPERTY,
	USAGE_PROCESS_CMDLINE_PROPERTY,
	USAGE_PROCESS_CMDLINE_PARAMETER_PROPERTY,
	USAGE_PROCESS_DISPLAY_NAME_PROPERTY,
	USAGE_PROCESS_UID_PROPERTY,
	USAGE_PROCESS_CPU_LOAD_PROPERTY,
	USAGE_PROCESS_X_CPU_LOAD_PROPERTY,
	USAGE_PROCESS_CPU_LAST_USED_PROPERTY,
	USAGE_PROCESS_X_CPU_LAST_USED_PROPERTY,
	USAGE_PROCESS_LAST_PROCESSOR_PROPERTY,
	USAGE_PROCESS_MEM_USAGE_PROPERTY,
	USAGE_PROCESS_SUB_PROCESSES_PROPERTY,
	USAGE_PROCESS_ALIVE_PROPERTY,
	USAGE_PROCESS_STATUS_PROPERTY,
	USAGE_PROCESS_NUM_PROPERTIES
};
static GParamSpec* usage_process_properties[USAGE_PROCESS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

struct _UsageProcess {
	GObject parent_instance;
	UsageProcessPrivate * priv;
};

struct _UsageProcessClass {
	GObjectClass parent_class;
};

typedef enum  {
	USAGE_PROCESS_STATUS_RUNNING,
	USAGE_PROCESS_STATUS_SLEEPING,
	USAGE_PROCESS_STATUS_DEAD
} UsageProcessStatus;

struct _UsageProcessPrivate {
	GPid _pid;
	gchar* _cmdline;
	gchar* _cmdline_parameter;
	gchar* _display_name;
	guint _uid;
	gdouble _cpu_load;
	gdouble _x_cpu_load;
	guint64 _cpu_last_used;
	guint64 _x_cpu_last_used;
	guint _last_processor;
	guint64 _mem_usage;
	GHashTable* _sub_processes;
	gboolean _alive;
	UsageProcessStatus _status;
};


static gint UsageProcess_private_offset;
static gpointer usage_process_parent_class = NULL;

GType usage_process_get_type (void) G_GNUC_CONST;
GType usage_process_status_get_type (void) G_GNUC_CONST;
UsageProcess* usage_process_new (GPid pid,
                                 const gchar* cmdline,
                                 const gchar* cmdline_parameter,
                                 const gchar* display_name,
                                 guint uid);
UsageProcess* usage_process_construct (GType object_type,
                                       GPid pid,
                                       const gchar* cmdline,
                                       const gchar* cmdline_parameter,
                                       const gchar* display_name,
                                       guint uid);
static void usage_process_set_pid (UsageProcess* self,
                            GPid value);
static void usage_process_set_cmdline (UsageProcess* self,
                                const gchar* value);
static void usage_process_set_cmdline_parameter (UsageProcess* self,
                                          const gchar* value);
static void usage_process_set_display_name (UsageProcess* self,
                                     const gchar* value);
static void usage_process_set_uid (UsageProcess* self,
                            guint value);
void usage_process_update_from_process (UsageProcess* self,
                                        UsageProcess* process);
guint usage_process_get_last_processor (UsageProcess* self);
void usage_process_set_last_processor (UsageProcess* self,
                                       guint value);
gdouble usage_process_get_cpu_load (UsageProcess* self);
void usage_process_set_cpu_load (UsageProcess* self,
                                 gdouble value);
gdouble usage_process_get_x_cpu_load (UsageProcess* self);
void usage_process_set_x_cpu_load (UsageProcess* self,
                                   gdouble value);
guint64 usage_process_get_cpu_last_used (UsageProcess* self);
void usage_process_set_cpu_last_used (UsageProcess* self,
                                      guint64 value);
guint64 usage_process_get_x_cpu_last_used (UsageProcess* self);
void usage_process_set_x_cpu_last_used (UsageProcess* self,
                                        guint64 value);
guint64 usage_process_get_mem_usage (UsageProcess* self);
void usage_process_set_mem_usage (UsageProcess* self,
                                  guint64 value);
gboolean usage_process_get_alive (UsageProcess* self);
void usage_process_set_alive (UsageProcess* self,
                              gboolean value);
UsageProcessStatus usage_process_get_status (UsageProcess* self);
void usage_process_set_status (UsageProcess* self,
                               UsageProcessStatus value);
GPid usage_process_get_pid (UsageProcess* self);
const gchar* usage_process_get_cmdline (UsageProcess* self);
const gchar* usage_process_get_cmdline_parameter (UsageProcess* self);
const gchar* usage_process_get_display_name (UsageProcess* self);
guint usage_process_get_uid (UsageProcess* self);
GHashTable* usage_process_get_sub_processes (UsageProcess* self);
void usage_process_set_sub_processes (UsageProcess* self,
                                      GHashTable* value);
static void usage_process_finalize (GObject * obj);
static void _vala_usage_process_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_usage_process_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);


static inline gpointer
usage_process_get_instance_private (UsageProcess* self)
{
	return G_STRUCT_MEMBER_P (self, UsageProcess_private_offset);
}


UsageProcess*
usage_process_construct (GType object_type,
                         GPid pid,
                         const gchar* cmdline,
                         const gchar* cmdline_parameter,
                         const gchar* display_name,
                         guint uid)
{
	UsageProcess * self = NULL;
	g_return_val_if_fail (cmdline != NULL, NULL);
	g_return_val_if_fail (cmdline_parameter != NULL, NULL);
	g_return_val_if_fail (display_name != NULL, NULL);
	self = (UsageProcess*) g_object_new (object_type, NULL);
	usage_process_set_pid (self, pid);
	usage_process_set_cmdline (self, cmdline);
	usage_process_set_cmdline_parameter (self, cmdline_parameter);
	usage_process_set_display_name (self, display_name);
	usage_process_set_uid (self, uid);
	return self;
}


UsageProcess*
usage_process_new (GPid pid,
                   const gchar* cmdline,
                   const gchar* cmdline_parameter,
                   const gchar* display_name,
                   guint uid)
{
	return usage_process_construct (USAGE_TYPE_PROCESS, pid, cmdline, cmdline_parameter, display_name, uid);
}


void
usage_process_update_from_process (UsageProcess* self,
                                   UsageProcess* process)
{
	guint _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	guint64 _tmp3_;
	guint64 _tmp4_;
	guint64 _tmp5_;
	gboolean _tmp6_;
	UsageProcessStatus _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (process != NULL);
	_tmp0_ = process->priv->_last_processor;
	usage_process_set_last_processor (self, _tmp0_);
	_tmp1_ = process->priv->_cpu_load;
	usage_process_set_cpu_load (self, _tmp1_);
	_tmp2_ = process->priv->_x_cpu_load;
	usage_process_set_x_cpu_load (self, _tmp2_);
	_tmp3_ = process->priv->_cpu_last_used;
	usage_process_set_cpu_last_used (self, _tmp3_);
	_tmp4_ = process->priv->_x_cpu_last_used;
	usage_process_set_x_cpu_last_used (self, _tmp4_);
	_tmp5_ = process->priv->_mem_usage;
	usage_process_set_mem_usage (self, _tmp5_);
	_tmp6_ = process->priv->_alive;
	usage_process_set_alive (self, _tmp6_);
	_tmp7_ = process->priv->_status;
	usage_process_set_status (self, _tmp7_);
}


GPid
usage_process_get_pid (UsageProcess* self)
{
	GPid result;
	GPid _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_pid;
	result = _tmp0_;
	return result;
}


static void
usage_process_set_pid (UsageProcess* self,
                       GPid value)
{
	g_return_if_fail (self != NULL);
	if (usage_process_get_pid (self) != value) {
		self->priv->_pid = value;
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_PID_PROPERTY]);
	}
}


const gchar*
usage_process_get_cmdline (UsageProcess* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_cmdline;
	result = _tmp0_;
	return result;
}


static void
usage_process_set_cmdline (UsageProcess* self,
                           const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, usage_process_get_cmdline (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_cmdline);
		self->priv->_cmdline = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_CMDLINE_PROPERTY]);
	}
}


const gchar*
usage_process_get_cmdline_parameter (UsageProcess* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_cmdline_parameter;
	result = _tmp0_;
	return result;
}


static void
usage_process_set_cmdline_parameter (UsageProcess* self,
                                     const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, usage_process_get_cmdline_parameter (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_cmdline_parameter);
		self->priv->_cmdline_parameter = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_CMDLINE_PARAMETER_PROPERTY]);
	}
}


const gchar*
usage_process_get_display_name (UsageProcess* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_display_name;
	result = _tmp0_;
	return result;
}


static void
usage_process_set_display_name (UsageProcess* self,
                                const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, usage_process_get_display_name (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_display_name);
		self->priv->_display_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_DISPLAY_NAME_PROPERTY]);
	}
}


guint
usage_process_get_uid (UsageProcess* self)
{
	guint result;
	guint _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_uid;
	result = _tmp0_;
	return result;
}


static void
usage_process_set_uid (UsageProcess* self,
                       guint value)
{
	g_return_if_fail (self != NULL);
	if (usage_process_get_uid (self) != value) {
		self->priv->_uid = value;
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_UID_PROPERTY]);
	}
}


gdouble
usage_process_get_cpu_load (UsageProcess* self)
{
	gdouble result;
	gdouble _tmp0_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->_cpu_load;
	result = _tmp0_;
	return result;
}


void
usage_process_set_cpu_load (UsageProcess* self,
                            gdouble value)
{
	g_return_if_fail (self != NULL);
	if (usage_process_get_cpu_load (self) != value) {
		self->priv->_cpu_load = value;
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_CPU_LOAD_PROPERTY]);
	}
}


gdouble
usage_process_get_x_cpu_load (UsageProcess* self)
{
	gdouble result;
	gdouble _tmp0_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->_x_cpu_load;
	result = _tmp0_;
	return result;
}


void
usage_process_set_x_cpu_load (UsageProcess* self,
                              gdouble value)
{
	g_return_if_fail (self != NULL);
	if (usage_process_get_x_cpu_load (self) != value) {
		self->priv->_x_cpu_load = value;
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_X_CPU_LOAD_PROPERTY]);
	}
}


guint64
usage_process_get_cpu_last_used (UsageProcess* self)
{
	guint64 result;
	guint64 _tmp0_;
	g_return_val_if_fail (self != NULL, 0ULL);
	_tmp0_ = self->priv->_cpu_last_used;
	result = _tmp0_;
	return result;
}


void
usage_process_set_cpu_last_used (UsageProcess* self,
                                 guint64 value)
{
	g_return_if_fail (self != NULL);
	if (usage_process_get_cpu_last_used (self) != value) {
		self->priv->_cpu_last_used = value;
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_CPU_LAST_USED_PROPERTY]);
	}
}


guint64
usage_process_get_x_cpu_last_used (UsageProcess* self)
{
	guint64 result;
	guint64 _tmp0_;
	g_return_val_if_fail (self != NULL, 0ULL);
	_tmp0_ = self->priv->_x_cpu_last_used;
	result = _tmp0_;
	return result;
}


void
usage_process_set_x_cpu_last_used (UsageProcess* self,
                                   guint64 value)
{
	g_return_if_fail (self != NULL);
	if (usage_process_get_x_cpu_last_used (self) != value) {
		self->priv->_x_cpu_last_used = value;
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_X_CPU_LAST_USED_PROPERTY]);
	}
}


guint
usage_process_get_last_processor (UsageProcess* self)
{
	guint result;
	guint _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_last_processor;
	result = _tmp0_;
	return result;
}


void
usage_process_set_last_processor (UsageProcess* self,
                                  guint value)
{
	g_return_if_fail (self != NULL);
	if (usage_process_get_last_processor (self) != value) {
		self->priv->_last_processor = value;
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_LAST_PROCESSOR_PROPERTY]);
	}
}


guint64
usage_process_get_mem_usage (UsageProcess* self)
{
	guint64 result;
	guint64 _tmp0_;
	g_return_val_if_fail (self != NULL, 0ULL);
	_tmp0_ = self->priv->_mem_usage;
	result = _tmp0_;
	return result;
}


void
usage_process_set_mem_usage (UsageProcess* self,
                             guint64 value)
{
	g_return_if_fail (self != NULL);
	if (usage_process_get_mem_usage (self) != value) {
		self->priv->_mem_usage = value;
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_MEM_USAGE_PROPERTY]);
	}
}


GHashTable*
usage_process_get_sub_processes (UsageProcess* self)
{
	GHashTable* result;
	GHashTable* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_sub_processes;
	result = _tmp0_;
	return result;
}


static gpointer
_g_hash_table_ref0 (gpointer self)
{
	return self ? g_hash_table_ref (self) : NULL;
}


void
usage_process_set_sub_processes (UsageProcess* self,
                                 GHashTable* value)
{
	g_return_if_fail (self != NULL);
	if (usage_process_get_sub_processes (self) != value) {
		GHashTable* _tmp0_;
		_tmp0_ = _g_hash_table_ref0 (value);
		_g_hash_table_unref0 (self->priv->_sub_processes);
		self->priv->_sub_processes = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_SUB_PROCESSES_PROPERTY]);
	}
}


gboolean
usage_process_get_alive (UsageProcess* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_alive;
	result = _tmp0_;
	return result;
}


void
usage_process_set_alive (UsageProcess* self,
                         gboolean value)
{
	g_return_if_fail (self != NULL);
	if (usage_process_get_alive (self) != value) {
		self->priv->_alive = value;
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_ALIVE_PROPERTY]);
	}
}


UsageProcessStatus
usage_process_get_status (UsageProcess* self)
{
	UsageProcessStatus result;
	UsageProcessStatus _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_status;
	result = _tmp0_;
	return result;
}


void
usage_process_set_status (UsageProcess* self,
                          UsageProcessStatus value)
{
	g_return_if_fail (self != NULL);
	if (usage_process_get_status (self) != value) {
		self->priv->_status = value;
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_STATUS_PROPERTY]);
	}
}


static void
usage_process_class_init (UsageProcessClass * klass)
{
	usage_process_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &UsageProcess_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_usage_process_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_usage_process_set_property;
	G_OBJECT_CLASS (klass)->finalize = usage_process_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_PID_PROPERTY, usage_process_properties[USAGE_PROCESS_PID_PROPERTY] = g_param_spec_int ("pid", "pid", "pid", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_CMDLINE_PROPERTY, usage_process_properties[USAGE_PROCESS_CMDLINE_PROPERTY] = g_param_spec_string ("cmdline", "cmdline", "cmdline", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_CMDLINE_PARAMETER_PROPERTY, usage_process_properties[USAGE_PROCESS_CMDLINE_PARAMETER_PROPERTY] = g_param_spec_string ("cmdline-parameter", "cmdline-parameter", "cmdline-parameter", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_DISPLAY_NAME_PROPERTY, usage_process_properties[USAGE_PROCESS_DISPLAY_NAME_PROPERTY] = g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_UID_PROPERTY, usage_process_properties[USAGE_PROCESS_UID_PROPERTY] = g_param_spec_uint ("uid", "uid", "uid", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_CPU_LOAD_PROPERTY, usage_process_properties[USAGE_PROCESS_CPU_LOAD_PROPERTY] = g_param_spec_double ("cpu-load", "cpu-load", "cpu-load", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_X_CPU_LOAD_PROPERTY, usage_process_properties[USAGE_PROCESS_X_CPU_LOAD_PROPERTY] = g_param_spec_double ("x-cpu-load", "x-cpu-load", "x-cpu-load", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_CPU_LAST_USED_PROPERTY, usage_process_properties[USAGE_PROCESS_CPU_LAST_USED_PROPERTY] = g_param_spec_uint64 ("cpu-last-used", "cpu-last-used", "cpu-last-used", 0, G_MAXUINT64, (guint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_X_CPU_LAST_USED_PROPERTY, usage_process_properties[USAGE_PROCESS_X_CPU_LAST_USED_PROPERTY] = g_param_spec_uint64 ("x-cpu-last-used", "x-cpu-last-used", "x-cpu-last-used", 0, G_MAXUINT64, (guint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_LAST_PROCESSOR_PROPERTY, usage_process_properties[USAGE_PROCESS_LAST_PROCESSOR_PROPERTY] = g_param_spec_uint ("last-processor", "last-processor", "last-processor", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_MEM_USAGE_PROPERTY, usage_process_properties[USAGE_PROCESS_MEM_USAGE_PROPERTY] = g_param_spec_uint64 ("mem-usage", "mem-usage", "mem-usage", 0, G_MAXUINT64, (guint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_SUB_PROCESSES_PROPERTY, usage_process_properties[USAGE_PROCESS_SUB_PROCESSES_PROPERTY] = g_param_spec_boxed ("sub-processes", "sub-processes", "sub-processes", G_TYPE_HASH_TABLE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_ALIVE_PROPERTY, usage_process_properties[USAGE_PROCESS_ALIVE_PROPERTY] = g_param_spec_boolean ("alive", "alive", "alive", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_STATUS_PROPERTY, usage_process_properties[USAGE_PROCESS_STATUS_PROPERTY] = g_param_spec_enum ("status", "status", "status", USAGE_TYPE_PROCESS_STATUS, USAGE_PROCESS_STATUS_SLEEPING, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void
usage_process_instance_init (UsageProcess * self)
{
	self->priv = usage_process_get_instance_private (self);
	self->priv->_cpu_load = (gdouble) 0;
	self->priv->_x_cpu_load = (gdouble) 0;
	self->priv->_cpu_last_used = (guint64) 0;
	self->priv->_x_cpu_last_used = (guint64) 0;
	self->priv->_last_processor = (guint) 0;
	self->priv->_mem_usage = (guint64) 0;
	self->priv->_alive = TRUE;
	self->priv->_status = USAGE_PROCESS_STATUS_SLEEPING;
}


static void
usage_process_finalize (GObject * obj)
{
	UsageProcess * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, USAGE_TYPE_PROCESS, UsageProcess);
	_g_free0 (self->priv->_cmdline);
	_g_free0 (self->priv->_cmdline_parameter);
	_g_free0 (self->priv->_display_name);
	_g_hash_table_unref0 (self->priv->_sub_processes);
	G_OBJECT_CLASS (usage_process_parent_class)->finalize (obj);
}


GType
usage_process_get_type (void)
{
	static volatile gsize usage_process_type_id__volatile = 0;
	if (g_once_init_enter (&usage_process_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UsageProcessClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) usage_process_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UsageProcess), 0, (GInstanceInitFunc) usage_process_instance_init, NULL };
		GType usage_process_type_id;
		usage_process_type_id = g_type_register_static (G_TYPE_OBJECT, "UsageProcess", &g_define_type_info, 0);
		UsageProcess_private_offset = g_type_add_instance_private (usage_process_type_id, sizeof (UsageProcessPrivate));
		g_once_init_leave (&usage_process_type_id__volatile, usage_process_type_id);
	}
	return usage_process_type_id__volatile;
}


static void
_vala_usage_process_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	UsageProcess * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, USAGE_TYPE_PROCESS, UsageProcess);
	switch (property_id) {
		case USAGE_PROCESS_PID_PROPERTY:
		g_value_set_int (value, usage_process_get_pid (self));
		break;
		case USAGE_PROCESS_CMDLINE_PROPERTY:
		g_value_set_string (value, usage_process_get_cmdline (self));
		break;
		case USAGE_PROCESS_CMDLINE_PARAMETER_PROPERTY:
		g_value_set_string (value, usage_process_get_cmdline_parameter (self));
		break;
		case USAGE_PROCESS_DISPLAY_NAME_PROPERTY:
		g_value_set_string (value, usage_process_get_display_name (self));
		break;
		case USAGE_PROCESS_UID_PROPERTY:
		g_value_set_uint (value, usage_process_get_uid (self));
		break;
		case USAGE_PROCESS_CPU_LOAD_PROPERTY:
		g_value_set_double (value, usage_process_get_cpu_load (self));
		break;
		case USAGE_PROCESS_X_CPU_LOAD_PROPERTY:
		g_value_set_double (value, usage_process_get_x_cpu_load (self));
		break;
		case USAGE_PROCESS_CPU_LAST_USED_PROPERTY:
		g_value_set_uint64 (value, usage_process_get_cpu_last_used (self));
		break;
		case USAGE_PROCESS_X_CPU_LAST_USED_PROPERTY:
		g_value_set_uint64 (value, usage_process_get_x_cpu_last_used (self));
		break;
		case USAGE_PROCESS_LAST_PROCESSOR_PROPERTY:
		g_value_set_uint (value, usage_process_get_last_processor (self));
		break;
		case USAGE_PROCESS_MEM_USAGE_PROPERTY:
		g_value_set_uint64 (value, usage_process_get_mem_usage (self));
		break;
		case USAGE_PROCESS_SUB_PROCESSES_PROPERTY:
		g_value_set_boxed (value, usage_process_get_sub_processes (self));
		break;
		case USAGE_PROCESS_ALIVE_PROPERTY:
		g_value_set_boolean (value, usage_process_get_alive (self));
		break;
		case USAGE_PROCESS_STATUS_PROPERTY:
		g_value_set_enum (value, usage_process_get_status (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_usage_process_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	UsageProcess * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, USAGE_TYPE_PROCESS, UsageProcess);
	switch (property_id) {
		case USAGE_PROCESS_PID_PROPERTY:
		usage_process_set_pid (self, g_value_get_int (value));
		break;
		case USAGE_PROCESS_CMDLINE_PROPERTY:
		usage_process_set_cmdline (self, g_value_get_string (value));
		break;
		case USAGE_PROCESS_CMDLINE_PARAMETER_PROPERTY:
		usage_process_set_cmdline_parameter (self, g_value_get_string (value));
		break;
		case USAGE_PROCESS_DISPLAY_NAME_PROPERTY:
		usage_process_set_display_name (self, g_value_get_string (value));
		break;
		case USAGE_PROCESS_UID_PROPERTY:
		usage_process_set_uid (self, g_value_get_uint (value));
		break;
		case USAGE_PROCESS_CPU_LOAD_PROPERTY:
		usage_process_set_cpu_load (self, g_value_get_double (value));
		break;
		case USAGE_PROCESS_X_CPU_LOAD_PROPERTY:
		usage_process_set_x_cpu_load (self, g_value_get_double (value));
		break;
		case USAGE_PROCESS_CPU_LAST_USED_PROPERTY:
		usage_process_set_cpu_last_used (self, g_value_get_uint64 (value));
		break;
		case USAGE_PROCESS_X_CPU_LAST_USED_PROPERTY:
		usage_process_set_x_cpu_last_used (self, g_value_get_uint64 (value));
		break;
		case USAGE_PROCESS_LAST_PROCESSOR_PROPERTY:
		usage_process_set_last_processor (self, g_value_get_uint (value));
		break;
		case USAGE_PROCESS_MEM_USAGE_PROPERTY:
		usage_process_set_mem_usage (self, g_value_get_uint64 (value));
		break;
		case USAGE_PROCESS_SUB_PROCESSES_PROPERTY:
		usage_process_set_sub_processes (self, g_value_get_boxed (value));
		break;
		case USAGE_PROCESS_ALIVE_PROPERTY:
		usage_process_set_alive (self, g_value_get_boolean (value));
		break;
		case USAGE_PROCESS_STATUS_PROPERTY:
		usage_process_set_status (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


GType
usage_process_status_get_type (void)
{
	static volatile gsize usage_process_status_type_id__volatile = 0;
	if (g_once_init_enter (&usage_process_status_type_id__volatile)) {
		static const GEnumValue values[] = {{USAGE_PROCESS_STATUS_RUNNING, "USAGE_PROCESS_STATUS_RUNNING", "running"}, {USAGE_PROCESS_STATUS_SLEEPING, "USAGE_PROCESS_STATUS_SLEEPING", "sleeping"}, {USAGE_PROCESS_STATUS_DEAD, "USAGE_PROCESS_STATUS_DEAD", "dead"}, {0, NULL, NULL}};
		GType usage_process_status_type_id;
		usage_process_status_type_id = g_enum_register_static ("UsageProcessStatus", values);
		g_once_init_leave (&usage_process_status_type_id__volatile, usage_process_status_type_id);
	}
	return usage_process_status_type_id__volatile;
}



