/* storage-item.c generated by valac 0.42.0, the Vala compiler
 * generated from storage-item.vala, do not modify */

/* storage-item.vala
 *
 * Copyright (C) 2017 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Petr Štětka <pstetka@redhat.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>


#define USAGE_TYPE_STORAGE_ITEM_POSITION (usage_storage_item_position_get_type ())

#define USAGE_TYPE_STORAGE_ITEM_TYPE (usage_storage_item_type_get_type ())

#define USAGE_TYPE_STORAGE_ITEM (usage_storage_item_get_type ())
#define USAGE_STORAGE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_STORAGE_ITEM, UsageStorageItem))
#define USAGE_STORAGE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_STORAGE_ITEM, UsageStorageItemClass))
#define USAGE_IS_STORAGE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_STORAGE_ITEM))
#define USAGE_IS_STORAGE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_STORAGE_ITEM))
#define USAGE_STORAGE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_STORAGE_ITEM, UsageStorageItemClass))

typedef struct _UsageStorageItem UsageStorageItem;
typedef struct _UsageStorageItemClass UsageStorageItemClass;
typedef struct _UsageStorageItemPrivate UsageStorageItemPrivate;
enum  {
	USAGE_STORAGE_ITEM_0_PROPERTY,
	USAGE_STORAGE_ITEM_NUM_PROPERTIES
};
static GParamSpec* usage_storage_item_properties[USAGE_STORAGE_ITEM_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	USAGE_STORAGE_ITEM_POSITION_FIRST,
	USAGE_STORAGE_ITEM_POSITION_SECOND,
	USAGE_STORAGE_ITEM_POSITION_THIRD,
	USAGE_STORAGE_ITEM_POSITION_ANYWHERE,
	USAGE_STORAGE_ITEM_POSITION_PENULTIMATE,
	USAGE_STORAGE_ITEM_POSITION_LAST
} UsageStorageItemPosition;

typedef enum  {
	USAGE_STORAGE_ITEM_TYPE_STORAGE,
	USAGE_STORAGE_ITEM_TYPE_SYSTEM,
	USAGE_STORAGE_ITEM_TYPE_DOCUMENTS,
	USAGE_STORAGE_ITEM_TYPE_DOWNLOADS,
	USAGE_STORAGE_ITEM_TYPE_DESKTOP,
	USAGE_STORAGE_ITEM_TYPE_MUSIC,
	USAGE_STORAGE_ITEM_TYPE_PICTURES,
	USAGE_STORAGE_ITEM_TYPE_VIDEOS,
	USAGE_STORAGE_ITEM_TYPE_TRASH,
	USAGE_STORAGE_ITEM_TYPE_TRASHFILE,
	USAGE_STORAGE_ITEM_TYPE_TRASHSUBFILE,
	USAGE_STORAGE_ITEM_TYPE_USER,
	USAGE_STORAGE_ITEM_TYPE_AVAILABLE,
	USAGE_STORAGE_ITEM_TYPE_FILE,
	USAGE_STORAGE_ITEM_TYPE_DIRECTORY
} UsageStorageItemType;

struct _UsageStorageItem {
	GObject parent_instance;
	UsageStorageItemPrivate * priv;
};

struct _UsageStorageItemClass {
	GObjectClass parent_class;
};

struct _UsageStorageItemPrivate {
	gchar* name;
	gchar* path;
	UsageStorageItemType type;
	UsageStorageItemType* parent;
	guint64 size;
	gdouble percentage;
	UsageStorageItemPosition prefered_position;
	gint section;
	GdkRGBA color;
};


static gint UsageStorageItem_private_offset;
static gpointer usage_storage_item_parent_class = NULL;

GType usage_storage_item_position_get_type (void) G_GNUC_CONST;
GType usage_storage_item_type_get_type (void) G_GNUC_CONST;
GType usage_storage_item_get_type (void) G_GNUC_CONST;
UsageStorageItem* usage_storage_item_new_item (UsageStorageItemType type,
                                               UsageStorageItemType* parent,
                                               const gchar* name,
                                               const gchar* path,
                                               guint64 size,
                                               gdouble percentage,
                                               gint section,
                                               UsageStorageItemPosition prefered_position);
UsageStorageItem* usage_storage_item_construct_item (GType object_type,
                                                     UsageStorageItemType type,
                                                     UsageStorageItemType* parent,
                                                     const gchar* name,
                                                     const gchar* path,
                                                     guint64 size,
                                                     gdouble percentage,
                                                     gint section,
                                                     UsageStorageItemPosition prefered_position);
static UsageStorageItemType* _usage_storage_item_type_dup (UsageStorageItemType* self);
UsageStorageItem* usage_storage_item_new_directory (UsageStorageItemType parent,
                                                    const gchar* name,
                                                    const gchar* path,
                                                    guint64 size,
                                                    gdouble percentage);
UsageStorageItem* usage_storage_item_construct_directory (GType object_type,
                                                          UsageStorageItemType parent,
                                                          const gchar* name,
                                                          const gchar* path,
                                                          guint64 size,
                                                          gdouble percentage);
UsageStorageItem* usage_storage_item_new_file (UsageStorageItemType parent,
                                               const gchar* name,
                                               const gchar* path,
                                               guint64 size,
                                               gdouble percentage);
UsageStorageItem* usage_storage_item_construct_file (GType object_type,
                                                     UsageStorageItemType parent,
                                                     const gchar* name,
                                                     const gchar* path,
                                                     guint64 size,
                                                     gdouble percentage);
UsageStorageItem* usage_storage_item_new_trash (const gchar* path,
                                                guint64 size,
                                                gdouble percentage,
                                                gint section);
UsageStorageItem* usage_storage_item_construct_trash (GType object_type,
                                                      const gchar* path,
                                                      guint64 size,
                                                      gdouble percentage,
                                                      gint section);
UsageStorageItem* usage_storage_item_new_storage (const gchar* name,
                                                  const gchar* path,
                                                  guint64 size,
                                                  gint section);
UsageStorageItem* usage_storage_item_construct_storage (GType object_type,
                                                        const gchar* name,
                                                        const gchar* path,
                                                        guint64 size,
                                                        gint section);
UsageStorageItem* usage_storage_item_new_system (guint64 size,
                                                 gdouble percentage,
                                                 gint section);
UsageStorageItem* usage_storage_item_construct_system (GType object_type,
                                                       guint64 size,
                                                       gdouble percentage,
                                                       gint section);
UsageStorageItem* usage_storage_item_new_available (guint64 size,
                                                    gdouble percentage,
                                                    gint section);
UsageStorageItem* usage_storage_item_construct_available (GType object_type,
                                                          guint64 size,
                                                          gdouble percentage,
                                                          gint section);
UsageStorageItemPosition usage_storage_item_get_prefered_position (UsageStorageItem* self);
void usage_storage_item_set_color (UsageStorageItem* self,
                                   GdkRGBA* color);
void usage_storage_item_get_color (UsageStorageItem* self,
                                   GdkRGBA* result);
gint usage_storage_item_get_section (UsageStorageItem* self);
guint64 usage_storage_item_get_size (UsageStorageItem* self);
gdouble usage_storage_item_get_percentage (UsageStorageItem* self);
gchar* usage_storage_item_get_name (UsageStorageItem* self);
UsageStorageItemType usage_storage_item_get_item_type (UsageStorageItem* self);
UsageStorageItemType* usage_storage_item_get_parent_type (UsageStorageItem* self);
gchar* usage_storage_item_get_path (UsageStorageItem* self);
UsageStorageItem* usage_storage_item_new (void);
UsageStorageItem* usage_storage_item_construct (GType object_type);
static void usage_storage_item_finalize (GObject * obj);


GType
usage_storage_item_position_get_type (void)
{
	static volatile gsize usage_storage_item_position_type_id__volatile = 0;
	if (g_once_init_enter (&usage_storage_item_position_type_id__volatile)) {
		static const GEnumValue values[] = {{USAGE_STORAGE_ITEM_POSITION_FIRST, "USAGE_STORAGE_ITEM_POSITION_FIRST", "first"}, {USAGE_STORAGE_ITEM_POSITION_SECOND, "USAGE_STORAGE_ITEM_POSITION_SECOND", "second"}, {USAGE_STORAGE_ITEM_POSITION_THIRD, "USAGE_STORAGE_ITEM_POSITION_THIRD", "third"}, {USAGE_STORAGE_ITEM_POSITION_ANYWHERE, "USAGE_STORAGE_ITEM_POSITION_ANYWHERE", "anywhere"}, {USAGE_STORAGE_ITEM_POSITION_PENULTIMATE, "USAGE_STORAGE_ITEM_POSITION_PENULTIMATE", "penultimate"}, {USAGE_STORAGE_ITEM_POSITION_LAST, "USAGE_STORAGE_ITEM_POSITION_LAST", "last"}, {0, NULL, NULL}};
		GType usage_storage_item_position_type_id;
		usage_storage_item_position_type_id = g_enum_register_static ("UsageStorageItemPosition", values);
		g_once_init_leave (&usage_storage_item_position_type_id__volatile, usage_storage_item_position_type_id);
	}
	return usage_storage_item_position_type_id__volatile;
}


GType
usage_storage_item_type_get_type (void)
{
	static volatile gsize usage_storage_item_type_type_id__volatile = 0;
	if (g_once_init_enter (&usage_storage_item_type_type_id__volatile)) {
		static const GEnumValue values[] = {{USAGE_STORAGE_ITEM_TYPE_STORAGE, "USAGE_STORAGE_ITEM_TYPE_STORAGE", "storage"}, {USAGE_STORAGE_ITEM_TYPE_SYSTEM, "USAGE_STORAGE_ITEM_TYPE_SYSTEM", "system"}, {USAGE_STORAGE_ITEM_TYPE_DOCUMENTS, "USAGE_STORAGE_ITEM_TYPE_DOCUMENTS", "documents"}, {USAGE_STORAGE_ITEM_TYPE_DOWNLOADS, "USAGE_STORAGE_ITEM_TYPE_DOWNLOADS", "downloads"}, {USAGE_STORAGE_ITEM_TYPE_DESKTOP, "USAGE_STORAGE_ITEM_TYPE_DESKTOP", "desktop"}, {USAGE_STORAGE_ITEM_TYPE_MUSIC, "USAGE_STORAGE_ITEM_TYPE_MUSIC", "music"}, {USAGE_STORAGE_ITEM_TYPE_PICTURES, "USAGE_STORAGE_ITEM_TYPE_PICTURES", "pictures"}, {USAGE_STORAGE_ITEM_TYPE_VIDEOS, "USAGE_STORAGE_ITEM_TYPE_VIDEOS", "videos"}, {USAGE_STORAGE_ITEM_TYPE_TRASH, "USAGE_STORAGE_ITEM_TYPE_TRASH", "trash"}, {USAGE_STORAGE_ITEM_TYPE_TRASHFILE, "USAGE_STORAGE_ITEM_TYPE_TRASHFILE", "trashfile"}, {USAGE_STORAGE_ITEM_TYPE_TRASHSUBFILE, "USAGE_STORAGE_ITEM_TYPE_TRASHSUBFILE", "trashsubfile"}, {USAGE_STORAGE_ITEM_TYPE_USER, "USAGE_STORAGE_ITEM_TYPE_USER", "user"}, {USAGE_STORAGE_ITEM_TYPE_AVAILABLE, "USAGE_STORAGE_ITEM_TYPE_AVAILABLE", "available"}, {USAGE_STORAGE_ITEM_TYPE_FILE, "USAGE_STORAGE_ITEM_TYPE_FILE", "file"}, {USAGE_STORAGE_ITEM_TYPE_DIRECTORY, "USAGE_STORAGE_ITEM_TYPE_DIRECTORY", "directory"}, {0, NULL, NULL}};
		GType usage_storage_item_type_type_id;
		usage_storage_item_type_type_id = g_enum_register_static ("UsageStorageItemType", values);
		g_once_init_leave (&usage_storage_item_type_type_id__volatile, usage_storage_item_type_type_id);
	}
	return usage_storage_item_type_type_id__volatile;
}


static inline gpointer
usage_storage_item_get_instance_private (UsageStorageItem* self)
{
	return G_STRUCT_MEMBER_P (self, UsageStorageItem_private_offset);
}


static UsageStorageItemType*
_usage_storage_item_type_dup (UsageStorageItemType* self)
{
	UsageStorageItemType* dup;
	dup = g_new0 (UsageStorageItemType, 1);
	memcpy (dup, self, sizeof (UsageStorageItemType));
	return dup;
}


static gpointer
__usage_storage_item_type_dup0 (gpointer self)
{
	return self ? _usage_storage_item_type_dup (self) : NULL;
}


UsageStorageItem*
usage_storage_item_construct_item (GType object_type,
                                   UsageStorageItemType type,
                                   UsageStorageItemType* parent,
                                   const gchar* name,
                                   const gchar* path,
                                   guint64 size,
                                   gdouble percentage,
                                   gint section,
                                   UsageStorageItemPosition prefered_position)
{
	UsageStorageItem * self = NULL;
	UsageStorageItemType* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	self = (UsageStorageItem*) g_object_new (object_type, NULL);
	self->priv->type = type;
	_tmp0_ = __usage_storage_item_type_dup0 (parent);
	_g_free0 (self->priv->parent);
	self->priv->parent = _tmp0_;
	_tmp1_ = g_strdup (name);
	_g_free0 (self->priv->name);
	self->priv->name = _tmp1_;
	_tmp2_ = g_strdup (path);
	_g_free0 (self->priv->path);
	self->priv->path = _tmp2_;
	self->priv->size = size;
	self->priv->percentage = percentage;
	self->priv->section = section;
	self->priv->prefered_position = prefered_position;
	return self;
}


UsageStorageItem*
usage_storage_item_new_item (UsageStorageItemType type,
                             UsageStorageItemType* parent,
                             const gchar* name,
                             const gchar* path,
                             guint64 size,
                             gdouble percentage,
                             gint section,
                             UsageStorageItemPosition prefered_position)
{
	return usage_storage_item_construct_item (USAGE_TYPE_STORAGE_ITEM, type, parent, name, path, size, percentage, section, prefered_position);
}


UsageStorageItem*
usage_storage_item_construct_directory (GType object_type,
                                        UsageStorageItemType parent,
                                        const gchar* name,
                                        const gchar* path,
                                        guint64 size,
                                        gdouble percentage)
{
	UsageStorageItem * self = NULL;
	UsageStorageItemType* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	self = (UsageStorageItem*) g_object_new (object_type, NULL);
	self->priv->type = USAGE_STORAGE_ITEM_TYPE_DIRECTORY;
	_tmp0_ = __usage_storage_item_type_dup0 (&parent);
	_g_free0 (self->priv->parent);
	self->priv->parent = _tmp0_;
	_tmp1_ = g_strdup (name);
	_g_free0 (self->priv->name);
	self->priv->name = _tmp1_;
	_tmp2_ = g_strdup (path);
	_g_free0 (self->priv->path);
	self->priv->path = _tmp2_;
	self->priv->size = size;
	self->priv->percentage = percentage;
	self->priv->section = 0;
	self->priv->prefered_position = USAGE_STORAGE_ITEM_POSITION_ANYWHERE;
	return self;
}


UsageStorageItem*
usage_storage_item_new_directory (UsageStorageItemType parent,
                                  const gchar* name,
                                  const gchar* path,
                                  guint64 size,
                                  gdouble percentage)
{
	return usage_storage_item_construct_directory (USAGE_TYPE_STORAGE_ITEM, parent, name, path, size, percentage);
}


UsageStorageItem*
usage_storage_item_construct_file (GType object_type,
                                   UsageStorageItemType parent,
                                   const gchar* name,
                                   const gchar* path,
                                   guint64 size,
                                   gdouble percentage)
{
	UsageStorageItem * self = NULL;
	UsageStorageItemType* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	self = (UsageStorageItem*) g_object_new (object_type, NULL);
	self->priv->type = USAGE_STORAGE_ITEM_TYPE_FILE;
	_tmp0_ = __usage_storage_item_type_dup0 (&parent);
	_g_free0 (self->priv->parent);
	self->priv->parent = _tmp0_;
	_tmp1_ = g_strdup (name);
	_g_free0 (self->priv->name);
	self->priv->name = _tmp1_;
	_tmp2_ = g_strdup (path);
	_g_free0 (self->priv->path);
	self->priv->path = _tmp2_;
	self->priv->size = size;
	self->priv->percentage = percentage;
	self->priv->section = 0;
	self->priv->prefered_position = USAGE_STORAGE_ITEM_POSITION_ANYWHERE;
	return self;
}


UsageStorageItem*
usage_storage_item_new_file (UsageStorageItemType parent,
                             const gchar* name,
                             const gchar* path,
                             guint64 size,
                             gdouble percentage)
{
	return usage_storage_item_construct_file (USAGE_TYPE_STORAGE_ITEM, parent, name, path, size, percentage);
}


UsageStorageItem*
usage_storage_item_construct_trash (GType object_type,
                                    const gchar* path,
                                    guint64 size,
                                    gdouble percentage,
                                    gint section)
{
	UsageStorageItem * self = NULL;
	UsageStorageItemType _tmp0_;
	UsageStorageItemType* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	g_return_val_if_fail (path != NULL, NULL);
	self = (UsageStorageItem*) g_object_new (object_type, NULL);
	self->priv->type = USAGE_STORAGE_ITEM_TYPE_TRASH;
	_tmp0_ = USAGE_STORAGE_ITEM_TYPE_TRASH;
	_tmp1_ = __usage_storage_item_type_dup0 (&_tmp0_);
	_g_free0 (self->priv->parent);
	self->priv->parent = _tmp1_;
	_tmp2_ = g_strdup (_ ("Trash"));
	_g_free0 (self->priv->name);
	self->priv->name = _tmp2_;
	_tmp3_ = g_strdup (path);
	_g_free0 (self->priv->path);
	self->priv->path = _tmp3_;
	self->priv->size = size;
	self->priv->percentage = percentage;
	self->priv->section = section;
	self->priv->prefered_position = USAGE_STORAGE_ITEM_POSITION_PENULTIMATE;
	return self;
}


UsageStorageItem*
usage_storage_item_new_trash (const gchar* path,
                              guint64 size,
                              gdouble percentage,
                              gint section)
{
	return usage_storage_item_construct_trash (USAGE_TYPE_STORAGE_ITEM, path, size, percentage, section);
}


UsageStorageItem*
usage_storage_item_construct_storage (GType object_type,
                                      const gchar* name,
                                      const gchar* path,
                                      guint64 size,
                                      gint section)
{
	UsageStorageItem * self = NULL;
	UsageStorageItemType _tmp0_;
	UsageStorageItemType* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	self = (UsageStorageItem*) g_object_new (object_type, NULL);
	self->priv->type = USAGE_STORAGE_ITEM_TYPE_STORAGE;
	_tmp0_ = USAGE_STORAGE_ITEM_TYPE_STORAGE;
	_tmp1_ = __usage_storage_item_type_dup0 (&_tmp0_);
	_g_free0 (self->priv->parent);
	self->priv->parent = _tmp1_;
	_tmp2_ = g_strdup (name);
	_g_free0 (self->priv->name);
	self->priv->name = _tmp2_;
	_tmp3_ = g_strdup (path);
	_g_free0 (self->priv->path);
	self->priv->path = _tmp3_;
	self->priv->size = size;
	self->priv->percentage = (gdouble) 0;
	self->priv->section = section;
	self->priv->prefered_position = USAGE_STORAGE_ITEM_POSITION_FIRST;
	return self;
}


UsageStorageItem*
usage_storage_item_new_storage (const gchar* name,
                                const gchar* path,
                                guint64 size,
                                gint section)
{
	return usage_storage_item_construct_storage (USAGE_TYPE_STORAGE_ITEM, name, path, size, section);
}


UsageStorageItem*
usage_storage_item_construct_system (GType object_type,
                                     guint64 size,
                                     gdouble percentage,
                                     gint section)
{
	UsageStorageItem * self = NULL;
	UsageStorageItemType _tmp0_;
	UsageStorageItemType* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	self = (UsageStorageItem*) g_object_new (object_type, NULL);
	self->priv->type = USAGE_STORAGE_ITEM_TYPE_SYSTEM;
	_tmp0_ = USAGE_STORAGE_ITEM_TYPE_SYSTEM;
	_tmp1_ = __usage_storage_item_type_dup0 (&_tmp0_);
	_g_free0 (self->priv->parent);
	self->priv->parent = _tmp1_;
	_tmp2_ = g_strdup (_ ("Operating System"));
	_g_free0 (self->priv->name);
	self->priv->name = _tmp2_;
	_tmp3_ = g_strdup ("");
	_g_free0 (self->priv->path);
	self->priv->path = _tmp3_;
	self->priv->size = size;
	self->priv->percentage = percentage;
	self->priv->section = section;
	self->priv->prefered_position = USAGE_STORAGE_ITEM_POSITION_SECOND;
	return self;
}


UsageStorageItem*
usage_storage_item_new_system (guint64 size,
                               gdouble percentage,
                               gint section)
{
	return usage_storage_item_construct_system (USAGE_TYPE_STORAGE_ITEM, size, percentage, section);
}


UsageStorageItem*
usage_storage_item_construct_available (GType object_type,
                                        guint64 size,
                                        gdouble percentage,
                                        gint section)
{
	UsageStorageItem * self = NULL;
	UsageStorageItemType _tmp0_;
	UsageStorageItemType* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	self = (UsageStorageItem*) g_object_new (object_type, NULL);
	self->priv->type = USAGE_STORAGE_ITEM_TYPE_AVAILABLE;
	_tmp0_ = USAGE_STORAGE_ITEM_TYPE_AVAILABLE;
	_tmp1_ = __usage_storage_item_type_dup0 (&_tmp0_);
	_g_free0 (self->priv->parent);
	self->priv->parent = _tmp1_;
	_tmp2_ = g_strdup (_ ("Available"));
	_g_free0 (self->priv->name);
	self->priv->name = _tmp2_;
	_tmp3_ = g_strdup ("");
	_g_free0 (self->priv->path);
	self->priv->path = _tmp3_;
	self->priv->size = size;
	self->priv->percentage = percentage;
	self->priv->section = section;
	self->priv->prefered_position = USAGE_STORAGE_ITEM_POSITION_LAST;
	return self;
}


UsageStorageItem*
usage_storage_item_new_available (guint64 size,
                                  gdouble percentage,
                                  gint section)
{
	return usage_storage_item_construct_available (USAGE_TYPE_STORAGE_ITEM, size, percentage, section);
}


UsageStorageItemPosition
usage_storage_item_get_prefered_position (UsageStorageItem* self)
{
	UsageStorageItemPosition result = 0;
	UsageStorageItemPosition _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->prefered_position;
	result = _tmp0_;
	return result;
}


void
usage_storage_item_set_color (UsageStorageItem* self,
                              GdkRGBA* color)
{
	GdkRGBA _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (color != NULL);
	_tmp0_ = *color;
	self->priv->color = _tmp0_;
}


void
usage_storage_item_get_color (UsageStorageItem* self,
                              GdkRGBA* result)
{
	GdkRGBA _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->color;
	*result = _tmp0_;
	return;
}


gint
usage_storage_item_get_section (UsageStorageItem* self)
{
	gint result = 0;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->section;
	result = _tmp0_;
	return result;
}


guint64
usage_storage_item_get_size (UsageStorageItem* self)
{
	guint64 result = 0ULL;
	guint64 _tmp0_;
	g_return_val_if_fail (self != NULL, 0ULL);
	_tmp0_ = self->priv->size;
	result = _tmp0_;
	return result;
}


gdouble
usage_storage_item_get_percentage (UsageStorageItem* self)
{
	gdouble result = 0.0;
	gdouble _tmp0_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->percentage;
	result = _tmp0_;
	return result;
}


gchar*
usage_storage_item_get_name (UsageStorageItem* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->name;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}


UsageStorageItemType
usage_storage_item_get_item_type (UsageStorageItem* self)
{
	UsageStorageItemType result = 0;
	UsageStorageItemType _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->type;
	result = _tmp0_;
	return result;
}


UsageStorageItemType*
usage_storage_item_get_parent_type (UsageStorageItem* self)
{
	UsageStorageItemType* result = NULL;
	UsageStorageItemType* _tmp0_;
	UsageStorageItemType* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->parent;
	_tmp1_ = __usage_storage_item_type_dup0 (_tmp0_);
	result = _tmp1_;
	return result;
}


gchar*
usage_storage_item_get_path (UsageStorageItem* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->path;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}


UsageStorageItem*
usage_storage_item_construct (GType object_type)
{
	UsageStorageItem * self = NULL;
	self = (UsageStorageItem*) g_object_new (object_type, NULL);
	return self;
}


UsageStorageItem*
usage_storage_item_new (void)
{
	return usage_storage_item_construct (USAGE_TYPE_STORAGE_ITEM);
}


static void
usage_storage_item_class_init (UsageStorageItemClass * klass)
{
	usage_storage_item_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &UsageStorageItem_private_offset);
	G_OBJECT_CLASS (klass)->finalize = usage_storage_item_finalize;
}


static void
usage_storage_item_instance_init (UsageStorageItem * self)
{
	self->priv = usage_storage_item_get_instance_private (self);
	self->priv->prefered_position = USAGE_STORAGE_ITEM_POSITION_ANYWHERE;
}


static void
usage_storage_item_finalize (GObject * obj)
{
	UsageStorageItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, USAGE_TYPE_STORAGE_ITEM, UsageStorageItem);
	_g_free0 (self->priv->name);
	_g_free0 (self->priv->path);
	_g_free0 (self->priv->parent);
	G_OBJECT_CLASS (usage_storage_item_parent_class)->finalize (obj);
}


GType
usage_storage_item_get_type (void)
{
	static volatile gsize usage_storage_item_type_id__volatile = 0;
	if (g_once_init_enter (&usage_storage_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UsageStorageItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) usage_storage_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UsageStorageItem), 0, (GInstanceInitFunc) usage_storage_item_instance_init, NULL };
		GType usage_storage_item_type_id;
		usage_storage_item_type_id = g_type_register_static (G_TYPE_OBJECT, "UsageStorageItem", &g_define_type_info, 0);
		UsageStorageItem_private_offset = g_type_add_instance_private (usage_storage_item_type_id, sizeof (UsageStorageItemPrivate));
		g_once_init_leave (&usage_storage_item_type_id__volatile, usage_storage_item_type_id);
	}
	return usage_storage_item_type_id__volatile;
}



